<template>
  <div class="seats-layout" :class="{ 'seats-layout--fullscreen': modes.fullscreen }">
    <FlightsCaseSeatsBalancing :leg="leg" :flight="flight" @autoPlacementDone="seatMapKey += 1"
      :lockEvent="lockEvent" />
    <FlightsCaseSeatsMap :leg="leg" :flight="flight" :modes="modes" :key="seatMapKey" @lock="lockEvent = !lockEvent"
      @panzoomInstance="panzoomInstance = $event" />
    <FlightsCaseSeatsActions :panzoomInstance="panzoomInstance" :modes="modes" :archived="flight.archived" />

    <Teleport to="#teleports">
      <v-toolbar class="footer-action-toolbar" color="white">
        <v-spacer></v-spacer>
        <v-btn variant="outlined" rounded size="large" :loading="loading" :disabled="!canFinalize()" @click="askFinalize()"
          data-cy="SeatsLayoutFinalizeBtn" class="inverted text-uppercase">
          Finaliser
        </v-btn>
      </v-toolbar>
    </Teleport> 
    <LazyFlightsCaseFinalizeDialog v-if="finalizeDialog" v-model="finalizeDialog" :legStatus="leg.status"
      @confirm="finalize($event)" @close="finalizeDialog = false" />
  </div>
</template>

<script setup lang="ts">
import { Leg } from "~/dto/leg.dto";
import { Flight } from "~/dto/flight.dto";

const { $api, $toast } = useNuxtApp();

const props = defineProps<{
  leg: Leg,
  flight: Flight
}>()


const panzoomInstance = ref(null);

const loading = ref(false);
const finalizeDialog = ref(false);
const seatMapKey = ref(0);
const lockEvent = ref(false);
const modes: Ref<any> = ref({
  commentMode: false,
  blockMode: false,
  placeMode: false,
  fullscreen: false
});

const askFinalize = () => {
  if (!canFinalize()) {
    return;
  }
  finalizeDialog.value = true;
}
const finalize = async ($event: any) => {
  loading.value = true;
  try {
    props.leg.documents = (await $api.leg.finalize(props.leg.id, $event)).documents;
    props.leg.status = await $api.leg.getStatus(props.leg.id);
    props.flight.documents = await $api.flightPaginated.getDocuments(props.flight.id);
    $toast.success("Génération des documents effectué");
  } catch (e) {
    $toast.error("Erreur lors de la génération des documents");
  }
  finalizeDialog.value = false;
  loading.value = false;
}
const canFinalize = () => {
  return ['scheduled', 'lmc'].includes(props.leg.status);
}

</script>

<style lang="scss">
.seats-layout {
  position: relative;
  height: 60vh;
  min-height: 460px;
  transition: all 0.5s;

  &--fullscreen {
    position: fixed;
    width: 100vw;
    height: 100vh;
    top: 0;
    left: 0;
    z-index: 5;
  }
}
</style>
